#ifndef getkey_h_
#define	getkey_h_

#include <util\atomic.h>                	// need "--std=c99"
#include <avr\interrupt.h>


#define time_t uint16_t				// up to 655360ms (~10min)


extern uint8_t key_state;			// debounced and inverted key state:
						// bit = 1: key pressed
extern uint8_t key_press;			// key press detect

extern uint8_t key_rpt;				// key long press and repeat


void get_key_init();				// timer for debounce and time stamp
uint8_t get_key_press( uint8_t key_mask );
uint8_t get_key_rpt( uint8_t key_mask );
uint8_t get_key_short( uint8_t key_mask );
uint8_t get_key_long( uint8_t key_mask );

time_t get_time_10ms();				// get time stamp


#endif
