#include "main.h"
#include "knightrider.h"
#include "pattern.h"
#include "getkey.h"


static uint8_t *start_pattern;			// point to first pattern
static uint8_t count;				// number of steps
static uint8_t step;				// current step
static uint8_t speed;				// current speed (10 .. 2550ms)
static time_t  delay;


uint8_t select( uint8_t num )
{
  uint8_t *ptr;
  uint8_t i, j;

  for( ptr = pattern; (i = *ptr++); ptr += j ){
    j = *ptr++;					// second entry = number of steps
    if( --num == 0 ){
      speed = i;
      count = j;
      start_pattern = ptr;			// point to first pattern
      step = 0;
      delay = get_time_10ms() - i;		// start immediately
      break;
    }
  }
  return num;					// 0 = successful
}


void run_pattern()
{
  if( get_time_10ms() - delay > speed ){
    delay += speed;
    LED_PORT = ~start_pattern[step];
    if( ++step >= count )
      step = 0;
  }
}
